#include <cassert>
#include <iostream>  
#include <fstream>

using namespace std;


int cost[4];
int costT=0;
int costTMOD=0;
int costInf;
int lenS;
int lenT;
string s;
string t;

int getCost(char a)
{
   switch(a)
   {
        case 'A':
           return cost[0];
           break;
        case 'C':
           return cost[1];
           break;
        case 'G':
           return cost[2];
           break;
        case 'T':
           return cost[3];
           break;
   }
}

int decrementa_cost(int posT, int posS, int cost_temp)
{
    int k = 1;
    while(k && posT<lenT && posS<lenS)
    {
        if(t[posT]==s[posS])
        {
           cost_temp-=getCost(t[posT]);
           posT++;
           posS++;
        }
        else
        {
           int w = 1;
           posT++;
           while(w && posT<lenT && posS<lenS)
           {
               if(t[posT]==s[posS])
               {
                    cost_temp-=getCost(t[posT]);
                    posT++;
                    posS++;
               }
               else
                    w = 0;
           }
           k = 0;
         }
     }
      return cost_temp;
}


int main()
{
    ifstream fin("Iinput0.txt"); assert(fin);
    getline(fin,s);
    getline(fin,t);
    
    for(int i=0; i<4; i++)
       fin >> cost[i];
    fin.close();

    lenS = s.length();
    lenT = t.length();
    
    for(int i=0; i<lenT; i++)
       costT+=getCost(t[i]);
    
    costTMOD = costInf = costT;
    
    for(int i=0; i<lenT; i++)
    {
        costT = costTMOD;
        for(int l=0; l<lenS; l++)
        {
           if(t[i]==s[l])
           {
               costT-=getCost(t[i]);
               costT=decrementa_cost(i+1,l+1,costT);
               if(costT<=costInf)
                  costInf=costT;
           }
           costT = costTMOD;
        }
     }

     ofstream fout("output.txt");
     fout << costInf <<endl;
     fout.close();
     return 0;
}
          

