#include <cassert>
#include <iostream>  
#include <fstream>

using namespace std;

string s;
string t;
int array[4];
int t_cost=0;
int tfix=0;
int min_cost;
int slenght;
int tlenght;


int getCst(char a);
int sub_cost(int pos_t, int pos_s, int temp);

int main()
{
    ifstream fin("Iinput0.txt"); assert(fin);
    getline(fin,s);
    getline(fin,t);
    
    for(int i=0; i<4; i++)
       fin >> array[i];
    fin.close();

    slenght = s.length();
    tlenght = t.length();
    
    for(int i=0; i<tlenght; i++)
       t_cost+=getCst(t[i]);
    
    tfix = min_cost = t_cost;
    
    for(int i=0; i<tlenght; i++)
    {
        t_cost = tfix;
        for(int l=0; l<slenght; l++)
        {
           if(t[i]==s[l])
           {
               t_cost-=getCst(t[i]);
               t_cost=sub_cost(i+1,l+1,t_cost);
               if(t_cost<=min_cost)
                  min_cost=t_cost;
           }
        t_cost=tfix;
        }
     }

     ofstream fout("output.txt");
     fout << min_cost <<endl;
     fout.close();
     return 0;
}


int sub_cost(int pos_t, int pos_s, int temp)
{
    int eq = 1;
    while(eq && pos_t<tlenght && pos_s<slenght)
    {
        if(t[pos_t]==s[pos_s])
        {
           temp-=getCst(t[pos_t]);
           pos_t++;
           pos_s++;
        }
        else
        {
           int posb = 1;
           pos_t++;
           while(posb && pos_t<tlenght && pos_s<slenght)
           {
               if(t[pos_t]==s[pos_s])
               {
                    temp-=getCst(t[pos_t]);
                    pos_t++;
                    pos_s++;
               }
               else
                    posb = 0;
           }
           eq = 0;
         }
     }
      return temp;
}

int getCst(char a)
{
   switch(a)
   {
        case 'A':
           return array[0];
           break;
        case 'C':
           return array[1];
           break;
        case 'G':
           return array[2];
           break;
        case 'T':
           return array[3];
           break;
   }
}


          

